net.sf.saxon.query

## Class LanguageFeature

- java.lang.Object
- - net.sf.saxon.query.LanguageFeature

-     public class LanguageFeature
      extends Object

  LanguageFeature represents a named XQuery 3.0 language feature as used in the require/prohibit feature declaration.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static LanguageFeature` | `ALL_EXTENSIONS`
    `static StructuredQName` | `ALL_OPTIONAL_FEATURES`
    `static int` | `ALWAYS`
    `static LanguageFeature` | `HIGHER_ORDER_FUNCTION`
    `static LanguageFeature` | `HIGHER_ORDER_FUNCTION_ALL_OPTIONAL_FEATURES`
    `static LanguageFeature` | `MODULE`
    `static LanguageFeature` | `MODULE_ALL_OPTIONAL_FEATURES`
    `static int` | `NEVER`
    `static int` | `OPTIONAL`
    `static LanguageFeature` | `SERIALIZATION`
    `static LanguageFeature` | `SERIALIZATION_ALL_OPTIONAL_FEATURES`
    `static LanguageFeature` | `STATIC_TYPING`
    `static LanguageFeature` | `STATIC_TYPING_ALL_OPTIONAL_FEATURES`
    `static LanguageFeature` | `TYPED_DATA`
    `static LanguageFeature` | `TYPED_DATA_ALL_OPTIONAL_FEATURES`
    `static LanguageFeature` | `TYPED_DATA_SCHEMAS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LanguageFeature(StructuredQName name, LanguageFeature parent, int availability)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Collection<LanguageFeature>` | `getAllOptionalFeatures()` Get the list of all recognized optional features
    `int` | `getAvailability()` Determine the availability of the feature in Saxon
    `Set<LanguageFeature>` | `getChildren()` Get the children of this feature
    `static LanguageFeature` | `getFeature(StructuredQName name)` Get the feature with a given name
    `StructuredQName` | `getName()` Get the name of the feature
    `LanguageFeature` | `getParent()` Get the parent (container) of the feature

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ALWAYS

          public static final int ALWAYS

      See Also:
        Constant Field Values

    - #### NEVER

          public static final int NEVER

      See Also:
        Constant Field Values

    - #### OPTIONAL

          public static final int OPTIONAL

      See Also:
        Constant Field Values

    - #### ALL_OPTIONAL_FEATURES

          public static final StructuredQName ALL_OPTIONAL_FEATURES

    - #### TYPED_DATA

          public static final LanguageFeature TYPED_DATA

    - #### TYPED_DATA_SCHEMAS

          public static final LanguageFeature TYPED_DATA_SCHEMAS

    - #### TYPED_DATA_ALL_OPTIONAL_FEATURES

          public static final LanguageFeature TYPED_DATA_ALL_OPTIONAL_FEATURES

    - #### STATIC_TYPING

          public static final LanguageFeature STATIC_TYPING

    - #### STATIC_TYPING_ALL_OPTIONAL_FEATURES

          public static final LanguageFeature STATIC_TYPING_ALL_OPTIONAL_FEATURES

    - #### SERIALIZATION

          public static final LanguageFeature SERIALIZATION

    - #### SERIALIZATION_ALL_OPTIONAL_FEATURES

          public static final LanguageFeature SERIALIZATION_ALL_OPTIONAL_FEATURES

    - #### MODULE

          public static final LanguageFeature MODULE

    - #### MODULE_ALL_OPTIONAL_FEATURES

          public static final LanguageFeature MODULE_ALL_OPTIONAL_FEATURES

    - #### HIGHER_ORDER_FUNCTION

          public static final LanguageFeature HIGHER_ORDER_FUNCTION

    - #### HIGHER_ORDER_FUNCTION_ALL_OPTIONAL_FEATURES

          public static final LanguageFeature HIGHER_ORDER_FUNCTION_ALL_OPTIONAL_FEATURES

    - #### ALL_EXTENSIONS

          public static final LanguageFeature ALL_EXTENSIONS

  - ### Constructor Detail

    - #### LanguageFeature

          public LanguageFeature(StructuredQName name,
                         LanguageFeature parent,
                         int availability)

  - ### Method Detail

    - #### getAllOptionalFeatures

          public static Collection<LanguageFeature> getAllOptionalFeatures()

      Get the list of all recognized optional features
      Returns:
        the collection of optional features defined in the XQuery specification

    - #### getName

          public StructuredQName getName()

      Get the name of the feature
      Returns:
        the name of the feature

    - #### getParent

          public LanguageFeature getParent()

      Get the parent (container) of the feature
      Returns:
        the parent (container) of the feature, or null if there is no parent

    - #### getChildren

          public Set<LanguageFeature> getChildren()

      Get the children of this feature
      Returns:
        the features of which this is the parent

    - #### getAvailability

          public int getAvailability()

      Determine the availability of the feature in Saxon
      Returns:
        whether the feature is always supported in Saxon, never supported in Saxon, or can be enabled/disabled in Saxon

    - #### getFeature

          public static LanguageFeature getFeature(StructuredQName name)

      Get the feature with a given name
      Parameters:
        `name` - the name of the feature
      Returns:
        the corresponding feature, or null if the name is unknown

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.